package halmaklient;

import java.awt.Component;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.io.FileReader;
import java.util.Properties;

import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class HalmaDialog {
	
	private JPanel panel;
	
	private JTextField tfName = null;
	private JTextField tfAddress = null;
	private JTextField tfPort = null;

	public HalmaDialog() {
		this.panel = new JPanel(new GridBagLayout());
		
		String name = "";
		String address = "";
		String port = "";

		try {
			Properties p = new Properties();
			p.load(new FileReader("halmaklient.ini"));
			name = p.getProperty("Player", "");
			address = p.getProperty("BindIP", "");
			port = p.getProperty("BindPort", "");
		} catch (Exception e) {
			;
		}
		
		this.tfName = new JTextField(name, 15);
		this.tfAddress = new JTextField(address, 11);
		this.tfPort = new JTextField(port, 5);
		
		GridBagConstraints c1 = new GridBagConstraints();
		GridBagConstraints c2 = new GridBagConstraints();
		
		c2.anchor = GridBagConstraints.NORTHWEST;
		c2.gridwidth = GridBagConstraints.REMAINDER;
		
		this.panel.add(new JLabel("Name "), c1);
		this.panel.add(this.tfName, c2);
		
		this.panel.add(new JLabel("Address "), c1);
		this.panel.add(this.tfAddress, c2);

		this.panel.add(new JLabel("Port "), c1);
		this.panel.add(this.tfPort, c2);
	}
	
	public int showDialog(Component c) {
		return JOptionPane.showConfirmDialog(c, this.panel, "henduse parameetrid...",
				JOptionPane.OK_CANCEL_OPTION);
	}
	
	public String getName() {
		return this.tfName.getText();
	}

	public String getAddress() {
		return this.tfAddress.getText();
	}

	public String getPort() {
		return this.tfPort.getText();
	}

}
