package halmaklient;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.Socket;
import java.net.UnknownHostException;

import javax.swing.JFrame;
import javax.swing.JOptionPane;

public class HalmaKlient extends JFrame {
	
	private static final long serialVersionUID = -2840438875692223279L;
	private String pealkiri = "Halma";
	
	HalmaLaud laud;
	
	Socket socket = null;
	PrintWriter valja = null;
	BufferedReader sisse = null;
	String nimi = null;
	
	public HalmaKlient() {
		super();
		this.setTitle(this.pealkiri);
		
		this.laud = new HalmaLaud();
		
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		this.getContentPane().add(this.laud);
		this.pack();
		this.setVisible(true);
	}
	
	public void init() throws NumberFormatException, UnknownHostException, IOException {
		HalmaDialog hd = new HalmaDialog();
		if (hd.showDialog(this) != JOptionPane.OK_OPTION) {
			System.exit(0);
		}
		
		this.socket = new Socket(hd.getAddress(), Integer.parseInt(hd.getPort()));
		this.sisse = new BufferedReader(new InputStreamReader(this.socket.getInputStream()));
		this.valja = new PrintWriter(this.socket.getOutputStream(), true);
		
		this.nimi = hd.getName();
	}
	
	private void saada(String l) {
System.err.println(">" + l);
		this.valja.print(l + "\n");
		this.valja.flush();
	}
	
	private String loe() throws IOException {
		String l = this.sisse.readLine();
System.err.println("<" + l);
		return l;
	}
	
	public void run() throws IOException {
		this.saada("play corner " + this.nimi);
		this.pealkiri = this.pealkiri + " - " + this.nimi;
		this.setTitle(this.pealkiri);
		
		while (true) {
			this.mangiMangu();
		}
	}
	
	private void mangiMangu() throws IOException {
		System.out.println("uus mng");
		int varv = HalmaLaud.TYHI;
		int kaija = HalmaLaud.MUST;
		String pealkiri2 = this.pealkiri;
		
		this.laud.initLaud();
		
		String kask = this.loe();
		
		if (kask.endsWith("start")) {
			varv = HalmaLaud.MUST;
			pealkiri2 = this.pealkiri + " - must";
			this.setTitle(pealkiri2);
		} else {
			varv = HalmaLaud.VALGE;
			pealkiri2 = this.pealkiri + " - valge";
			this.setTitle(pealkiri2);
		}
		
		while (!this.laud.mangLabi()) {
			if (varv == kaija) {
				this.setTitle("*" + pealkiri2 + " [sinu kik]");
				this.saada(this.laud.annaKaik(varv));
			} else {
				this.setTitle(pealkiri2 + " [vastase kik]");

				kask = this.loe();
				
				if (kask.startsWith("end")) {
					JOptionPane.showMessageDialog(this, "Vastane tegi vigase kigu");
					break;
				}

				if (kask.startsWith("error")) {
					JOptionPane.showMessageDialog(this, "Mina tegin vigase kigu :(");
					break;
				}

				this.laud.teeKaik(kask);
			}
			
			kaija = -kaija;
		}
		
		JOptionPane.showMessageDialog(this, "Mng lbi");
	}

	public static void main(String[] args) throws Exception {
		HalmaKlient hk = new HalmaKlient();
		try {
			hk.init();
			hk.run();
		} catch (Exception e) {
			JOptionPane.showMessageDialog(hk, "Exception: " + e.getMessage(), "Viga!", JOptionPane.ERROR_MESSAGE);
			e.printStackTrace();
			System.exit(0);
		}
	}

}
