package halmaklient;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;

import javax.swing.JButton;

public class HamaRuut extends JButton {

	private static final long serialVersionUID = 1438342518467759647L;

	private int veerg;
	private int rida;
	
	private int seis;
	private boolean valitud = false;
	private boolean voib = false;
	
	public HamaRuut(int v, int r) {
		this.veerg = v;
		this.rida = r;
		
		this.setToolTipText("[" + this.veerg + "," + this.rida + "]");
		this.setActionCommand("[" + this.veerg + "," + this.rida + "]");
	}
	
	public void paint(Graphics g) {
		super.paint(g);
		Graphics2D g2 = (Graphics2D)g;
		
		if (this.seis == HalmaLaud.VALGE) {
			this.joonistaNupp(g2, Color.BLACK, Color.WHITE);
		}

		if (this.seis == HalmaLaud.MUST) {
			this.joonistaNupp(g2, Color.BLACK, Color.BLACK);
		}
		
		if (this.voib) this.joonistaServ(g2, Color.GREEN);
		if (this.valitud) this.joonistaServ(g2, Color.BLUE);
	}
	
	private void joonistaServ(Graphics2D g2, Color varv) {
		int h = this.getHeight();
		int w = this.getWidth();

		g2.setColor(varv);
		g2.drawRect(1, 1, w-2, h-2);
		g2.drawRect(2, 2, w-4, h-4);
	}

	private void joonistaNupp(Graphics2D g2, Color serv, Color sisu) {
		int h = this.getHeight();
		int w = this.getWidth();

		int sh = (int)(h*0.1);
		int sw = (int)(w*0.1);
		
		g2.setColor(sisu);
		g2.fillRect(sw, sh, w-2*sw, h-2*sh);
		g2.setColor(serv);
		g2.drawRect(sw, sh, w-2*sw, h-2*sh);
	}

	public void seaSeis(int s) {
		this.seis = s;
		this.repaint();
	}
	
	public void seaVoib(boolean b) {
		if (this.voib != b) {
			this.voib = b;
			this.repaint();
		}
	}
	
	public void seaValitud(boolean b) {
		if (this.valitud != b) {
			this.valitud = b;
			this.repaint();
		}
	}
	
	public void tyhistaSeisundid() {
		this.seaVoib(false);
		this.seaValitud(false);
	}
	
}
